Subject: Re: [PATCH] fast-import: Allow filemodify to set the root

From: Jonathan Nieder <[email-masked]>
Date: Thu, 7 Oct 2010 15:28:47 -0500

Sverre Rabbelier wrote:

> This means nothing to me

Sorry for the lack of clarity.  Probably I should have just said:

| For a command (like filter-branch --subdirectory-filter) that wants
| to commit a lot of trees that already exist in the object db, writing
| undeltified objects as loose files only to repack them later can
| involve a significant amount[*] of overhead.
|
| Fortunately we have fast-import (which is one of the only git commands
| that will write to a pack directly) but there is not an advertised way
| to tell fast-import to commit a given tree without unpacking it.
|
| This patch changes that, by allowing
|
|        M 040000 <tree id> ""
|
| as a filemodify line in a commit to reset to a particular tree without
| any need to parse it.  For example,
|
|	M 040000 4b825dc642cb6eb9a060e54bf8d69288fbee4904 ""
|
| is a synonym for the deleteall command.

[*] how significant?  Numbers are always nice. :)

> Ok, so maybe I do understand, is it basically 'git read-tree
> 4b825dc642cb6eb9a060e54bf8d69288fbee4904' for fast-import?

Yep.

Thanks.